package wdp63;

import static org.hamcrest.CoreMatchers.is;
import static org.junit.Assert.assertThat;

import java.util.ArrayList;

import org.junit.Before;
import org.junit.Test;
import org.junit.experimental.runners.Enclosed;
import org.junit.runner.RunWith;

@RunWith(Enclosed.class)
public class ArrayListTest {

    public static class インスタンス化直後のList {
        private ArrayList<String> list;

        @Before
        public void 前準備() {
            list = new ArrayList<String>();
        }

        @Test
        public void サイズは0() throws Exception {
            assertThat(list.size(), is(0));
        }

        @Test
        public void isEmptyはtrue() throws Exception {
            assertThat(list.isEmpty(), is(true));
        }
    }

    public static class 文字列を2つ入れた場合 {
        private ArrayList<String> list;

        @Before
        public void 前準備() {
            list = new ArrayList<String>();
            list.add("foo");
            list.add("bar");
        }

        @Test
        public void サイズは2() throws Exception {
            assertThat(list.size(), is(2));
        }

        @Test
        public void isEmptyはfalse() throws Exception {
            assertThat(list.isEmpty(), is(false));
        }

        @Test
        public void 後から入れた要素のindexは1() throws Exception {
            assertThat(list.indexOf("bar"), is(1));
        }
    }

    public static class 要素を2つ入れた後最初の要素を削除した場合 {
        private ArrayList<String> list;

        @Before
        public void 前準備() {
            list = new ArrayList<String>();
            list.add("foo");
            list.add("bar");
            list.remove("foo");
        }

        @Test
        public void サイズは1() throws Exception {
            assertThat(list.size(), is(1));
        }

        @Test
        public void isEmptyはfalse() throws Exception {
            assertThat(list.isEmpty(), is(false));
        }

        @Test
        public void 後から入れた要素のindexが減る()
            throws Exception {
            assertThat(list.indexOf("bar"), is(0));
        }
    }
}
